
import socket
import re
import datetime
import time


def generate_time(hour,minute):
	date_time=datetime.datetime.today()
	if ( hour < date_time.hour ):
		td=datetime.timedelta(days=1)
		date_time=date_time+td
	date_time=date_time.replace(hour=hour,minute=minute)
	return date_time

class vdrinterface:
	def __init__(self,host='',port=2001):
		self.host=host
		self.port=port
		self.s=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	
	def connect(self):
		try:
			self.s.connect((self.host,self.port))
			self.connection=self.s.makefile("rw",0)
			self.ReceiveResponse()
			return True
		except socket.error, msg:
			self.s.close()
			return (False,msg)
		return False

	def close(self):
		self.s.close()

	def send(self,command):
		self.connection.write(command+"\r\n")

	def receive(self):
		line_in=self.connection.readline()
		x=re.match("(\\d{1,4})(-|\\s)(.*)",line_in)
		errorcode=int(x.group(1))
		last_line=x.group(2)==" "
		text=x.group(3)
		return (errorcode,last_line,text)

	def SendCommand(self,command):
		self.send(command)
		return self.ReceiveResponse()

	def ReceiveResponse(self):
		bend=False
		result=[]
		while (not bend):
			(err,last,text)=self.receive()
			result.append(text.strip())
			if (last):
				bend=True
		return result
		
	# aktiv:Kanal:Tag:Start:End:Prio:Dauerhaftigkeit:Titel:
	def NewSingleTimer(self,title,channel,starttime,duration_min,prio=80,lifetime=20,active=True ,minutesBefore=5,minutesAfter=15):
		td1=datetime.timedelta(minutes=minutesBefore)
		start_time=starttime-td1
		end_time=starttime+datetime.timedelta(minutes=(minutesAfter+duration_min))
		str_date=start_time.strftime("%Y-%m-%d")
		str_start=start_time.strftime("%H%M")
		str_end=end_time.strftime("%H%M")
		if ( active ):
			i_active=1
		else:
			i_active=0
		command="newt %s:%d:%s:%s:%s:%d:%d:%s:" % (i_active,channel,str_date,str_start,str_end,prio,lifetime,title)
		print command
		return self.SendCommand(command)

	def QueryEpg(self,date_and_time,sender):
		tt=date_and_time.timetuple()
		time_l=time.mktime(tt)
		list=self.SendCommand("lste %d at %d" % (sender,int(time_l)))
		result={}
		for line in list:
			r=re.match("([CETD])(-|\\s)(.*)",line)
			if ( r != None ):
				g=r.group(1)
				if ( g == "C" ):
					result["Channel"]=r.group(3)
				elif ( g == "E" ):
					line=r.group(3)
					table=line.split()
					result["EventID"]=table[0]
					result["Start"]=datetime.datetime.fromtimestamp(int(table[1]))
					result["Duration"]=int(table[2])
					result["TableID"]=table[3]
				elif ( g == "T" ):
					result["Title"]=r.group(3)
				elif ( g== "D" ):
					result["Description"]=r.group(3)
		return result
		