
import vdr
import datetime
import string
import capisuite
import os


my_pin="1974"

def speak(call,text):
	filetitle=string.lower(text)
	trans=string.maketrans("?#+*./\\: <>@","_______oaus-____")
	filetitle=string.translate(filetitle,trans)
	filename="/var/spool/capisuite/voice/"+filetitle+".la"
	if (os.access(filename,os.R_OK) ):
		capisuite.log("ok file exists: %s" % (filetitle),1,call)
	else:
		capisuite.log("File must be created: \"%s\" " % (filetitle),1,call)
		# create file
		os.spawnlp(os.P_WAIT,"cs_gen_la","cs_gen_la",filetitle,text)
	capisuite.log("Es wird gesprochen \"%s\"" % (text),1,call)
	capisuite.audio_send(call,filename,1)


def get_sender(call):
	sendernames=["pro 7","sat 1","Kabel 1","R T L","R T L 2","Vox"]
	sendernr=[4,5,6,3,7,8]
	i=0
	for sendername in sendernames:
		i+=1
		text="Die %d fr %s" % (i,sendername)
		speak(call,text)
		choice=capisuite.read_DTMF(call,0)
		if (choice != ""):
			choice=int(choice)-1
			return (sendernr[choice],sendernames[choice])
	choice=capisuite.read_DTMF(call,0)
	if (choice != ""):
		choice=int(choice)-1
		return (sendernr[choice],sendernames[choice])
	return (-1,"")

def get_epg_for(snr,hour,minute,vdri):
	time=vdr.generate_time(hour,minute)
	td=datetime.timedelta(minutes=5)
	time+=td
	return vdri.QueryEpg(time,snr)
	
def vdr_call(call):
	speak(call,"Willkommen beim Video Disk Rekorder Fon System")
	vdri=vdr.vdrinterface()
	if ( not vdri.connect() ):
		speak(call,"Verbindung zum vdr fehlgeschlagen. Auf Wiederhren.")
		capisuite.log("No VDR",1,call)
		capisuite.disconnect(call)
		return

	speak(call,"drcken sie bitte")
	(snr,sname)=get_sender(call)
	if (snr == -1 ):
		speak(call,"Kein Sender gewhlt. Auf Wiederhren.")
		capisuite.log("No sender chosen",1,call)
		capisuite.disconnect(call)
		vdri.close()
		return
	speak(call,"%s wurde als Sender gewhlt" % (sname))

	speak(call,"Bitte Startzeit eingeben")
	start_time=capisuite.read_DTMF(call,10,0,4)
	if (not start_time.isdigit() ):
		speak(call,"Falsche Uhrzeit. Auf Wiederhren.")
		capisuite.log("Wrong time %s" % (start_time),1,call)
		capisuite.disconnect(call)
		vdri.close()
		return
	hour=start_time[:2]
	minute=start_time[2:]
	speak(call,"Startzeit wurde auf %s Uhr %s festgelegt." % (hour,minute))
	epg_data=get_epg_for(snr,int(hour),int(minute),vdri)
	if ( epg_data.has_key("Title") ):
		speak(call,"Es wird %s aufgenommen" % (epg_data["Title"]))
	else:
		speak(call,"Keine E P G Daten. Auf Wiederhren.")
		capisuite.disconnect(call)
		vdri.close()
		return
	speak(call,"Bitte besttigen indem Sie dreimal Stern drcken")
	dtmf_list=capisuite.read_DTMF(call,10,1,3)
	
	if ( dtmf_list!="***" ):
		speak(call,"Besttigung nicht erfolgt - ich wiederhole - Besttigung nicht erfolgt")
		capisuite.disconnect(call)
		vdri.close()
		return
	
	speak(call,"Besttigung erfolgt - Einstellungen werden gespeichert")
	#title,channel,starttime,duration_min
	rtitle=epg_data["Title"]+" by Phone"
	rduration=int(epg_data["Duration"]/60)
	save_success=vdri.NewSingleTimer(rtitle, snr,epg_data["Start"],rduration)
	if ( save_success ):
		speak(call,"Teimer gespeichert. auf Wiederhren")
	else:
		speak(call,"Teimer nicht gepseichert - ich wiederhole - Teimer nicht gespeichert")
	
	vdri.close()
	capisuite.disconnect(call)
	